Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 698978 - www-client/firefox should support Python 3
Summary: www-client/firefox should support Python 3
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All All
: Normal normal with 2 votes (vote)
Assignee: Mozilla Gentoo Team
URL:
Whiteboard:
Keywords:
: 731958 739276 (view as bug list)
Depends on:
Blocks: py3-tracker, python-3-incompatible
  Show dependency tree
 
Reported: 2019-10-31 02:53 UTC by Arfrever Frehtes Taifersar Arahesis
Modified: 2020-09-30 01:09 UTC (History)
19 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Comment 1 Ionen Wolkens 2019-10-31 04:13:48 UTC
I "think" the only version which still doesn't is 52.9.0 and <60 versions been masked for a year for having multiple vulnerabilities. Time to just remove?
Comment 2 Arfrever Frehtes Taifersar Arahesis 2019-10-31 04:21:33 UTC
Firefox versions >=61 use both Python 2 and Python 3 in different parts of build system. See bug #662456.
It is not yet possible to build Firefox using only Python 3.
Comment 3 Ingo Brunberg 2020-06-22 07:48:56 UTC
The bug that describes the issue of building firefox with Python 3 is now marked as resolved.

https://bugzilla.mozilla.org/show_bug.cgi?id=1388447
Comment 4 Thomas Deutschmann gentoo-dev Security 2020-07-09 17:57:48 UTC
*** Bug 731958 has been marked as a duplicate of this bug. ***
Comment 5 Jack 2020-07-29 19:11:47 UTC
That mozilla  bug says "We both 1) support and 2) require Python 3 to build Firefox today. I'm closing this bug as complete in light of that." as of a month ago.  Any idea which version of firefox that will actually apply to?  I still get that firefox-79.0 requires python:2.7.
Comment 6 charles17 2020-07-29 20:35:53 UTC
(In reply to Jack from comment #5)
> [...]
> I still get that firefox-79.0 requires python:2.7.

Find upstream tracking bug ( Support python 3 across Firefox projects ):
https://bugzilla.mozilla.org/showdependencytree.cgi?id=1496527&hide_resolved=1
Comment 7 Thomas Bettler 2020-07-30 15:57:23 UTC
indeed firefox >= 78 does no longer need python2.
Comment 8 Jack 2020-07-30 16:01:13 UTC
emerge -pc python:2.7 gives me 

Calculating dependencies... done!
  dev-lang/python-2.7.18-r1 pulled in by:
    www-client/firefox-79.0 requires dev-lang/python:2.7[ncurses,sqlite,ssl,threads(+)]
and five other packages.
Comment 9 Thomas Bettler 2020-07-30 16:28:57 UTC
(In reply to Jack from comment #8)
> emerge -pc python:2.7 gives me 
> 
> Calculating dependencies... done!
>   dev-lang/python-2.7.18-r1 pulled in by:
>     www-client/firefox-79.0 requires
> dev-lang/python:2.7[ncurses,sqlite,ssl,threads(+)]
> and five other packages.

good point, the mozcoreconf eclass needs to be corrected, i.e. drop py2 dependency.
Comment 10 Jack 2020-07-30 17:17:03 UTC
Thanks.  I thought I was losing it, and wondered if portage had something stuck in its throat.  

I don't know if this is relevant, but "emerge --info firefox" includes the line BOOTSTRAP_USE="unicode internal-glib pkg-config split-usr python_targets_python3_7 python_targets_python2_7 multilib"
and all other mentions of python are just 3_7.  I have no idea where that comes from, however.
Comment 11 Thomas Deutschmann gentoo-dev Security 2020-07-30 17:58:51 UTC
The plan is to do that with new eclasses when also moving to EAPI 7. I have no plans to change current eclasses.
Comment 12 Sam James archtester gentoo-dev Security 2020-08-27 15:19:36 UTC
*** Bug 739276 has been marked as a duplicate of this bug. ***
Comment 13 pagorman 2020-09-29 00:52:38 UTC
In a local overlay, copying the eclass over, incrementing it to mozcoreconfv7, and replacing python2_7 with python3_7? also requires removing the now-defunct "threads" useflag. Editing the firefox ebuild to remove this defunct useflag as a requirement of python is also required.

This causes firefox to build, and to function appropriately. I am using it to submit this report.

However, attempting to remove the defunct python package has me rebuilding spidermonkey - an error entirely of my own. I  After looking at the latest security reports on this bugzilla, I am choosing to increment to 78.3.0 for the spidermonkey build.

This build went without a hitch - even the existing patches applied for spidermonkey-78.2.0 seem to apply just as well as with their intended target. No edits were applied to this ebuild, aside from renaming and placing in the local overlay.

I will be reusing my modified ebuild for firefox-80.0.1-"r2" to install firefox-81.0

I will report back after attempting a firefox build - I have a simpler backup webbrowser.
Comment 14 pagorman 2020-09-29 03:43:38 UTC
my local/python2-less "=www-client/firefox-80.0.1-r2" is re-built against the spidermonkey-78.3.0. And python2 disappears after 'emerge --depclean'. The browser is functioning as intended.

The old (python2.7) version of spidermonkey was required by polkit - adding a keyword for a newer version of sys-auth/polkit addresses this need.
Comment 15 Larry the Git Cow gentoo-dev 2020-09-29 23:39:56 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ed273ce18a8de3340424291814e8376b4e787792

commit ed273ce18a8de3340424291814e8376b4e787792
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2020-09-29 23:29:43 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2020-09-29 23:39:33 +0000

    www-client/firefox: bump to v81.0
    
    Bug: https://bugs.gentoo.org/698978
    Bug: https://bugs.gentoo.org/744208
    Package-Manager: Portage-3.0.8, Repoman-3.0.1
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 www-client/firefox/Manifest                        |   97 ++
 www-client/firefox/files/gentoo-default-prefs.js   |   13 +
 www-client/firefox/files/gentoo-hwaccel-prefs.js-1 |    1 +
 www-client/firefox/files/icon/firefox-symbolic.svg |   64 ++
 www-client/firefox/firefox-81.0.ebuild             | 1028 ++++++++++++++++++++
 5 files changed, 1203 insertions(+)
Comment 16 Larry the Git Cow gentoo-dev 2020-09-30 01:09:47 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=eaf416cbcda53918cbd9250877bf1bd76ed5f5c1

commit eaf416cbcda53918cbd9250877bf1bd76ed5f5c1
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2020-09-30 01:02:06 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2020-09-30 01:05:11 +0000

    www-client/firefox: bump to v78.3.0
    
    Closes: https://bugs.gentoo.org/698978
    Closes: https://bugs.gentoo.org/734924
    Bug: https://bugs.gentoo.org/744208
    Package-Manager: Portage-3.0.8, Repoman-3.0.1
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 www-client/firefox/Manifest              |   97 +++
 www-client/firefox/firefox-78.3.0.ebuild | 1028 ++++++++++++++++++++++++++++++
 2 files changed, 1125 insertions(+)